<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::gadgetManager Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.6.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html">gadgetManager</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::gadgetManager Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager_1_1test"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager_1_1test.html">test</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a7565b6996444ed95de30aa741948eb26"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a7565b6996444ed95de30aa741948eb26">isSpecialCharacter</a> (uint8_t byte)</td></tr>
<tr class="separator:a7565b6996444ed95de30aa741948eb26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada73dca8b646e75f28d1e781ea41d3e5"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ada73dca8b646e75f28d1e781ea41d3e5">getChecksumSection</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:ada73dca8b646e75f28d1e781ea41d3e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa39c87e852b345c1d4c2a94d28470b5"><td class="memItemLeft" align="right" valign="top">static uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#afa39c87e852b345c1d4c2a94d28470b5">readChecksum</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:afa39c87e852b345c1d4c2a94d28470b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad86459621e78499b7967b1d07a1bca31"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ad86459621e78499b7967b1d07a1bca31">getPayloadSection</a> (const std::vector&lt; uint8_t &gt; &amp;packet)</td></tr>
<tr class="separator:ad86459621e78499b7967b1d07a1bca31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66cb11a1998f9b2b3f5029f8a3657f35"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a66cb11a1998f9b2b3f5029f8a3657f35">append</a> (uint8_t byte, std::vector&lt; uint8_t &gt; *v)</td></tr>
<tr class="separator:a66cb11a1998f9b2b3f5029f8a3657f35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ded4da80b7ddb12eb0e1050b1224b3e"><td class="memItemLeft" align="right" valign="top">static uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#a7ded4da80b7ddb12eb0e1050b1224b3e">getNextSequenceId</a> (uint8_t sequenceId)</td></tr>
<tr class="separator:a7ded4da80b7ddb12eb0e1050b1224b3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:ac579aa39c558bfd83ea02294039b180d"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ac579aa39c558bfd83ea02294039b180d">COMMAND_ID_INDEX</a> = 1</td></tr>
<tr class="memdesc:ac579aa39c558bfd83ea02294039b180d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Command ID value in a properly formed GadgetProtocol packet.  <a href="#ac579aa39c558bfd83ea02294039b180d">More...</a><br /></td></tr>
<tr class="separator:ac579aa39c558bfd83ea02294039b180d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae703b1adc155200ebaf07248988520e9"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ae703b1adc155200ebaf07248988520e9">ERROR_ID_INDEX</a> = 2</td></tr>
<tr class="memdesc:ae703b1adc155200ebaf07248988520e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Error ID value in a properly formed GadgetProtocol packet.  <a href="#ae703b1adc155200ebaf07248988520e9">More...</a><br /></td></tr>
<tr class="separator:ae703b1adc155200ebaf07248988520e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad917a1f3173195877547bb5fc60b846a"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1gadget_manager.html#ad917a1f3173195877547bb5fc60b846a">SEQUENCE_ID_INDEX</a> = 3</td></tr>
<tr class="memdesc:ad917a1f3173195877547bb5fc60b846a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Location of Sequence ID value in a properly formed GadgetProtocol packet.  <a href="#ad917a1f3173195877547bb5fc60b846a">More...</a><br /></td></tr>
<tr class="separator:ad917a1f3173195877547bb5fc60b846a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a66cb11a1998f9b2b3f5029f8a3657f35"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66cb11a1998f9b2b3f5029f8a3657f35">&#9670;&nbsp;</a></span>append()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void alexaClientSDK::capabilityAgents::gadgetManager::append </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>byte</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; uint8_t &gt; *&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Properly escape (if required) and append a byte onto a vector</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">byte</td><td>the byte to append </td></tr>
    <tr><td class="paramname">v</td><td>the vector to append to </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ada73dca8b646e75f28d1e781ea41d3e5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada73dca8b646e75f28d1e781ea41d3e5">&#9670;&nbsp;</a></span>getChecksumSection()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::vector&lt;uint8_t&gt; alexaClientSDK::capabilityAgents::gadgetManager::getChecksumSection </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; uint8_t &gt; &amp;&#160;</td>
          <td class="paramname"><em>packet</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>The checksum is the penultimate 16 bits (in big-endian form), unless the checksum contains one of the special characters. If that is the case, the special characters are escaped as they would be in the payload. This makes for a bit of ugliness in determining the actual bytes of the checksum. Starting at the end of the packet, we search for a four-byte checksum, then a three-byte checksum and if neither of those match, it's a two byte checksum. This function returns a 2, 3 or 4 byte-vector with the segment that represents the checksum. This function requires a properly formatted Gadget Protocol packet.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">packet</td><td>a properly formatted Gadget Protocol packet </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a vector of the checksum portion of the packet. </dd></dl>

</div>
</div>
<a id="a7ded4da80b7ddb12eb0e1050b1224b3e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7ded4da80b7ddb12eb0e1050b1224b3e">&#9670;&nbsp;</a></span>getNextSequenceId()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static uint8_t alexaClientSDK::capabilityAgents::gadgetManager::getNextSequenceId </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>sequenceId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Function to simplify the handling of the sequenceId. The sequenceId is incremented, rolling over from 0xFF-&gt;0x00. Special characters are skipped.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sequenceId</td><td>the previous sequence ID </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the next sequence ID </dd></dl>

</div>
</div>
<a id="ad86459621e78499b7967b1d07a1bca31"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad86459621e78499b7967b1d07a1bca31">&#9670;&nbsp;</a></span>getPayloadSection()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::vector&lt;uint8_t&gt; alexaClientSDK::capabilityAgents::gadgetManager::getPayloadSection </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; uint8_t &gt; &amp;&#160;</td>
          <td class="paramname"><em>packet</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Cut off the head and footer of a Gadget Protocol packet.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">packet</td><td>a properly formatted Gadget Protocol packet </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the still-escaped payload of the Gadget Protocol packet. </dd></dl>

</div>
</div>
<a id="a7565b6996444ed95de30aa741948eb26"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7565b6996444ed95de30aa741948eb26">&#9670;&nbsp;</a></span>isSpecialCharacter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool alexaClientSDK::capabilityAgents::gadgetManager::isSpecialCharacter </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>byte</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">byte</td><td>The character the needs determination if it is a special character within the Gadget Protocol. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if byte is a special character. </dd></dl>

</div>
</div>
<a id="afa39c87e852b345c1d4c2a94d28470b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afa39c87e852b345c1d4c2a94d28470b5">&#9670;&nbsp;</a></span>readChecksum()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static uint16_t alexaClientSDK::capabilityAgents::gadgetManager::readChecksum </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; uint8_t &gt; &amp;&#160;</td>
          <td class="paramname"><em>packet</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This returns the 16-bit checksum of what is stored in the packet (not what is calculated). If necessary, it is byte-swapped, as it is in big-endian form in the packet.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">packet</td><td>a properly formatted Gadget Protocol packet </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the checksum of the packet </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="ac579aa39c558bfd83ea02294039b180d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac579aa39c558bfd83ea02294039b180d">&#9670;&nbsp;</a></span>COMMAND_ID_INDEX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const size_t alexaClientSDK::capabilityAgents::gadgetManager::COMMAND_ID_INDEX = 1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Location of Command ID value in a properly formed GadgetProtocol packet. </p>

</div>
</div>
<a id="ae703b1adc155200ebaf07248988520e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae703b1adc155200ebaf07248988520e9">&#9670;&nbsp;</a></span>ERROR_ID_INDEX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const size_t alexaClientSDK::capabilityAgents::gadgetManager::ERROR_ID_INDEX = 2</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Location of Error ID value in a properly formed GadgetProtocol packet. </p>

</div>
</div>
<a id="ad917a1f3173195877547bb5fc60b846a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad917a1f3173195877547bb5fc60b846a">&#9670;&nbsp;</a></span>SEQUENCE_ID_INDEX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const size_t alexaClientSDK::capabilityAgents::gadgetManager::SEQUENCE_ID_INDEX = 3</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Location of Sequence ID value in a properly formed GadgetProtocol packet. </p>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.6.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
